/* FILENAME: CHESS.CPP
 * LAST UPDATE: 17.01.2016
 */

#include "CHESS.H"

//  
int Result_count = 0;

/* Clear field function */
//  
void chess::Clear( void )
{
	//   
	for (int i = 0; i < N; i++)
		for (int j = 0; j < M; j++)
			Field[i][j] = Free;
} // End of 'Clear' function

/* Check if the cell is available that function */
// ,      
int chess::IsAvailable( int x, int y )
{
	if (x >= 0 && y >= 0 && x < M && y < N)
		if (Field[y][x] == Free)
		  return 1;
	
	return 0;
} // End of 'IsAvailable' function

/* Output field in file function */
//     
void chess::OutputInFile( void )
{
	//     FILE
	FILE *F;

	//      
	fopen_s(&F, "chess.txt", "at");

	//     
	fputc('\n', F);

	//    
	for (int i = 0; i < N; ++i)
	{
		// '*' -  ; '#' - ,   
		for (int j = 0; j < M; ++j)
			(Field[i][j] == Free || Field[i][j] == busy) ? fputc('*', F) : fputc('#', F);
		//     
		fputc('\n', F);
	}

	//  
	fclose(F);
} /* End of 'OutputInFile' function */

/* Copy desks function */
//  
void chess::Copy( chess &desk2 )
{
  for (int i = 0; i < N; i++)
		for (int j = 0; j < M; j++)
			desk2.Field[i][j] = Field[i][j];
} // End of 'Copy' function

/* Fill field function */
//       
// Chessmen_num -  ,   ; Already_stood - ,   
int chess::FillField( int IsCount, type set, int x, int y, int Chessmen_num, int Already_stood )
{
	int i, j, k, l;
	chess desk2(N, M);

	//  
	desk2.Clear();

	//      ,   ,      
	for (i = y; i < N; i++)
		for (j = ((i == y) ? x : 0); j < M; j++)
		{
			//   
			if (Field[i][j] == Free)
			{
				//  
				Copy(desk2);
				
				//    
				switch (set)
				{
				// 
				case castle:
					for (k = 0; k < N; k++) 
					{ 
						//   
						if (desk2.Field[k][j] == Free)
						  desk2.Field[k][j] = busy; 
						//   
						if (desk2.Field[i][k] == Free)
						  desk2.Field[i][k] = busy; 
					}
					break;
				// 
				case bishop:
					//        
					for (k = 1 - (N < M ? N : M); k < (N < M ? N : M); k++)
					{ 
						//         
						if (IsAvailable(j + k, i + k))
							desk2.Field[i + k][j + k] = busy;
						//       
						if (IsAvailable(j + k, i - k))
							desk2.Field[i - k][j + k] = busy;
					}
					break;
				// 
				case knight:
					//  , k -   X, l -  Y
					k = -2, l = 1; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					
					k = -2, l = -1; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					
					k = -1, l = 2; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					
					k = -1, l = -2; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					
					k = 1, l = 2; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					
					k = 1, l = -2; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					
					k = 2, l = 1; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					
					k = 2, l = -1; 
					//      
					if (IsAvailable(j + k, i + l))
						desk2.Field[i + l][j + k] = busy;
					break;
				// 
				case queen:
					for (k = 0; k < N; k++)
					{
						//   
						if (desk2.Field[k][j] == Free)
							desk2.Field[k][j] = busy;
						//   
						if (desk2.Field[i][k] == Free)
							desk2.Field[i][k] = busy;
					}
					
					//        
					for (k = 1 - (N < M ? N : M); k < (N < M ? N : M); k++)
					{
						//         
						if (IsAvailable(j + k, i + k))
							desk2.Field[i + k][j + k] = busy;
						//       
						if (IsAvailable(j + k, i - k))
							desk2.Field[i - k][j + k] = busy;
					}
					break;
				// 
				case king:
				  //    3  3,    ,    
					for (k = -1; k < 2; k++)
						for (l = -1; l < 2; l++)
							if (IsAvailable(j + k, i + l))
								desk2.Field[i + l][j + k] = busy;
					break;
				}
				//     
				desk2.Field[i][j] = set;
        
				// ,    ,    ,     
				if ((Already_stood + 1) < Chessmen_num)
				{
					//     ,    
					if (IsCount == 0)
						desk2.FillField(IsCount, set, j, i, Chessmen_num, Already_stood + 1);
					//               ,   1
					else if ((IsCount == 1) && desk2.FillField(IsCount, set, j, i, Chessmen_num, Already_stood + 1))
						return 1;
				}

				//        
				else if ((Already_stood + 1) == Chessmen_num)
				{
					//     ,             
					if (IsCount == 0)
					{
						Result_count++;
					  desk2.OutputInFile();
					}
					//        ,   ,  1
					else if (IsCount == 1)
						return 1;
			  }
			}
		}
		//     ,    
		if (IsCount == 0)
		  return Result_count;
		//        ,   0
		else if (IsCount == 1)
		  return 0;
} // End of 'FillField' function

// END OF 'CHESS.CPP' FILE