/* FILENAME: CHESS.H
 * LAST UPDATE: 17.01.2016
 */

#ifndef __CHESS_H_ 
#define __CHESS_H_

#include <iostream>
#include <conio.h>

using namespace std;

// , , , , , , 
enum type { Free, busy, castle, bishop, knight, queen, king };

/* Chess class */
class chess
{
private:
	//   
	type **Field;
	//   ;   
	int N, M;
public:
	/* Default constructor */
	chess( void )
	{
		N = 8, M = 8;
		
		//     
		Field = new type*[N];
		for (int i = 0; i < N; i++)
			Field[i] = new type[M];
	}
	
	/* Class constructor */
	chess( int _N, int _M ) : N(_N), M(_M)
	{
		//     
		Field = new type* [N];
		for (int i = 0; i < N; i++)
			Field[i] = new type [M];
	}

	/* Class destructor */
	~chess( void )
	{
		//  
		for (int i = 0; i < N; i++)
			delete[] Field[i];
		delete[] Field;
	}

	/* Clear field function */
	void Clear( void );
	
	/* Check if the cell is available that function */
	int IsAvailable( int x, int y );
		
	/* Output field in file function */
	void OutputInFile( void );
	
	/* Copy desks function */
	void Copy( chess& desk2 );
	
	/* Fill field function */
	int FillField ( int IsCount, type set, int x, int y, int Chessmen_num, int Already_stood);
}; // end of 'chess' class

#endif /*__CHESS_H_ */

// END OF 'CHESS.H' FILE